﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace jordan_svd
{
    /**
     *  Class that calculates the speed of the  Zero polynomial matrix calculation
     */
    public class PoliSpeedAnalisys
    {
        /**
         * The random number generator.
         */ 
        protected Random rnd1 = new Random();

        /**
         * The results
         */ 
        public long [] times;

        /**
         * The default constructor.
         */ 
        public PoliSpeedAnalisys()
        {
            
        }

        /**
         * Performs the speed calculation.
         */ 
        public void performCalculations(int maxSize , int vathmos , System.Windows.Forms.Label info)
        {
            times = new long[maxSize+1];
            vathmos++;

            long ticksPerSecond;
            PerformanceCounter ct = new PerformanceCounter();
            ticksPerSecond = ct.QueryPerformanceFrequency();


            int start = 2;
            ArrayList poli;
            for (int i = start; i < maxSize+1; i++)
            {
                poli = new ArrayList();
                for (int k = 0; k < vathmos; k++)
                {
                    double[,] mat = getRandomMatrix(i);
                    poli.Add(mat);
                }
                ZeroPolynomialMatrixCalculation polionimAlgorithm = new ZeroPolynomialMatrixCalculation();
                polionimAlgorithm.setPolionimikoPinaka(poli);
                polionimAlgorithm.solve();
                info.Text = "Βαθμός " + (vathmos - 1) + "  Διάσταση " + i + "Χ" + i + "  χρόνος:" + (polionimAlgorithm.totalTime / (ticksPerSecond/1000) ) ;
                System.Windows.Forms.Application.DoEvents();
                times[i] = (polionimAlgorithm.totalTime / (ticksPerSecond/1000));
            }
        }


        /**
         * Reutrns randon squere matrix nXn size.
         */
        public double[,] getRandomMatrix(int size)
        {
            double[,] result = new double[size, size];

            for (int i = 0; i < size; i++)
            {
                for( int j = 0 ; j < size ; j++) 
                {
                    result[i, j] = rnd1.NextDouble();
                }
            }

            return result;
        }
    }
}
